Index: issm/trunk-jpl/src/c/classes/Elements/Element.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Element.h	(revision 19279)
+++ issm/trunk-jpl/src/c/classes/Elements/Element.h	(revision 19282)
@@ -122,5 +122,4 @@
 		void               LinearFloatingiceMeltingRate(); 
 		void               MigrateGroundingLine(IssmDouble* sheet_ungrounding);
-		void               Marshall(char** pmarshalled_data,int* pmarshalled_data_size, int marshall_direction,int numanalyses);
 		ElementMatrix*     NewElementMatrix(int approximation_enum=NoneApproximationEnum);
 		ElementMatrix*     NewElementMatrixCoupling(int number_nodes,int approximation_enum=NoneApproximationEnum);
@@ -228,4 +227,5 @@
 		virtual void       JacobianDeterminantSurface(IssmDouble* Jdet, IssmDouble* xyz_list,Gauss* gauss)=0;
 		virtual void       JacobianDeterminantTop(IssmDouble* Jdet,IssmDouble* xyz_list_base,Gauss* gauss)=0;
+		virtual void       Marshall(char** pmarshalled_data,int* pmarshalled_data_size, int marshall_direction,int numanalyses);
 		virtual IssmDouble Masscon(IssmDouble* levelset)=0;
 		virtual IssmDouble MassFlux(IssmDouble* segment)=0;
Index: issm/trunk-jpl/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/FemModel.cpp	(revision 19279)
+++ issm/trunk-jpl/src/c/classes/FemModel.cpp	(revision 19282)
@@ -764,5 +764,5 @@
 		}
 
-		/*Reset current configuration: */
+		//Reset current configuration:
 		analysis_type=this->analysis_type_list[analysis_counter];
 		SetCurrentConfiguration(analysis_type);
Index: issm/trunk-jpl/src/c/classes/Materials/Matice.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matice.cpp	(revision 19279)
+++ issm/trunk-jpl/src/c/classes/Materials/Matice.cpp	(revision 19282)
@@ -30,4 +30,5 @@
 	this->helement=NULL;
 	this->element=NULL;
+	this->isdamaged=false;
 	return;
 }
Index: issm/trunk-jpl/src/c/classes/Materials/Matpar.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matpar.cpp	(revision 19279)
+++ issm/trunk-jpl/src/c/classes/Materials/Matpar.cpp	(revision 19282)
@@ -18,4 +18,53 @@
 /*}}}*/
 Matpar::Matpar(int matpar_mid, IoModel* iomodel){/*{{{*/
+
+	rho_ice=0;
+	rho_water=0;
+	rho_freshwater=0;
+	mu_water=0;
+	heatcapacity=0;
+	thermalconductivity=0;
+	temperateiceconductivity=0;
+	latentheat=0;
+	beta=0;
+	meltingpoint=0;
+	referencetemperature=0;
+	mixed_layer_capacity=0;
+	thermal_exchange_velocity=0;
+	g=0;
+	omega=0;
+	desfac=0;
+	s0p=0;
+	s0t=0;
+	rlaps=0;
+	rlapslgm=0;
+	dpermil=0;
+
+	sediment_compressibility=0;
+	sediment_porosity=0;
+	sediment_thickness=0;
+	water_compressibility=0;
+
+	epl_compressibility=0;
+	epl_porosity=0;
+	epl_init_thickness=0;
+	epl_colapse_thickness=0;
+	epl_max_thickness=0;
+	epl_conductivity=0;
+
+	lithosphere_shear_modulus=0;
+	lithosphere_density=0;
+	mantle_shear_modulus=0;
+	mantle_density=0;
+
+	poisson=0;
+	young_modulus=0;
+	ridging_exponent=0;
+	cohesion=0;
+	internal_friction_coef=0;
+	compression_coef=0;
+	traction_coef=0;
+	time_relaxation_stress=0;
+	time_relaxation_damage=0;
 
 	bool isefficientlayer;
@@ -151,7 +200,7 @@
 }		
 /*}}}*/
-int    Matpar::Id(void){ return mid; }/*{{{*/
-/*}}}*/
-int Matpar::ObjectEnum(void){/*{{{*/
+int  Matpar::Id(void){ return mid; }/*{{{*/
+/*}}}*/
+int  Matpar::ObjectEnum(void){/*{{{*/
 
 	return MatparEnum;
@@ -237,5 +286,5 @@
 	MARSHALLING(dpermil);
 
-	/*hydrology Dual Porous Continuum: */
+	//hydrology Dual Porous Continuum:
 	MARSHALLING(sediment_compressibility);
 	MARSHALLING(sediment_porosity);
@@ -250,5 +299,5 @@
 	MARSHALLING(epl_conductivity);
 
-	/*gia: */
+	//gia:
 	MARSHALLING(lithosphere_shear_modulus);
 	MARSHALLING(lithosphere_density);
@@ -256,5 +305,5 @@
 	MARSHALLING(mantle_density);
 
-	/*Sea ice*/
+	//Sea ice:
 	MARSHALLING(poisson);
 	MARSHALLING(young_modulus);
Index: issm/trunk-jpl/src/c/datastructures/DataSet.cpp
===================================================================
--- issm/trunk-jpl/src/c/datastructures/DataSet.cpp	(revision 19279)
+++ issm/trunk-jpl/src/c/datastructures/DataSet.cpp	(revision 19282)
@@ -29,4 +29,6 @@
 	sorted=0;
 	numsorted=0;
+	presorted=0;
+	enum_type=-1;
 	sorted_ids=NULL;
 	id_offsets=NULL;
@@ -38,4 +40,6 @@
 
 	sorted=0;
+	numsorted=0;
+	presorted=0;
 	sorted_ids=NULL;
 	id_offsets=NULL;
@@ -87,5 +91,5 @@
 
 /*Specific methods*/
-void DataSet::Marshall(char** pmarshalled_data, int* pmarshalled_data_size, int marshall_direction){ /*{{{*/
+void  DataSet::Marshall(char** pmarshalled_data, int* pmarshalled_data_size, int marshall_direction){ /*{{{*/
 	
 	vector<Object*>::iterator obj;