Index: issm/trunk-jpl/src/m/plot/applyoptions.py
===================================================================
--- issm/trunk-jpl/src/m/plot/applyoptions.py	(revision 19460)
+++ issm/trunk-jpl/src/m/plot/applyoptions.py	(revision 19462)
@@ -216,37 +216,37 @@
 	#colorbar {{{
 	if options.getfieldvalue('colorbar',1)==1:
-		if cbar_extend==0:
-			extend='neither'
-		elif cbar_extend==1:
-			extend='max'
-		elif cbar_extend==2:
-			extend='min'
-		elif cbar_extend==3:
-			extend='both'
-		cb = mpl.colorbar.ColorbarBase(ax.cax, cmap=cmap, norm=norm, extend=extend)
-		if options.exist('alpha'):
-			cb.set_alpha(options.getfieldvalue('alpha'))
-		if options.exist('colorbarnumticks'):
-			cb.locator=MaxNLocator(nbins=options.getfieldvalue('colorbarnumticks',5))
-		else:
-			cb.locator=MaxNLocator(nbins=5) # default 5 ticks
-		if options.exist('colorbartickspacing'):
-			locs=npy.arange(lims[0],lims[1]+1,options.getfieldvalue('colorbartickspacing'))
-			cb.set_ticks(locs)
-		if options.exist('colorbarlines'):
-			locs=npy.arange(lims[0],lims[1]+1,options.getfieldvalue('colorbarlines'))
-			cb.add_lines(locs,['k' for i in range(len(locs))],npy.ones_like(locs))
-		if options.exist('colorbartitle'):
-			if options.exist('colorbartitlepad'):
-				cb.set_label(options.getfieldvalue('colorbartitle'),\
-						labelpad=options.getfieldvalue('colorbartitlepad'),fontsize=fontsize)
-			else:
-				cb.set_label(options.getfieldvalue('colorbartitle'),fontsize=fontsize)
-		cb.ax.tick_params(labelsize=fontsize)
-                cb.solids.set_rasterized(True)
-		cb.update_ticks()
-                cb.set_alpha(1)
-                cb.draw_all()
-		plt.sca(ax) # return to original axes control
+	    if cbar_extend==0:
+	    	extend='neither'
+	    elif cbar_extend==1:
+	    	extend='max'
+	    elif cbar_extend==2:
+	    	extend='min'
+	    elif cbar_extend==3:
+	    	extend='both'
+	    cb = mpl.colorbar.ColorbarBase(ax.cax, cmap=cmap, norm=norm, extend=extend)
+	    if options.exist('alpha'):
+	    	cb.set_alpha(options.getfieldvalue('alpha'))
+	    if options.exist('colorbarnumticks'):
+	    	cb.locator=MaxNLocator(nbins=options.getfieldvalue('colorbarnumticks',5))
+	    else:
+	    	cb.locator=MaxNLocator(nbins=5) # default 5 ticks
+	    if options.exist('colorbartickspacing'):
+	    	locs=npy.arange(lims[0],lims[1]+1,options.getfieldvalue('colorbartickspacing'))
+	    	cb.set_ticks(locs)
+	    if options.exist('colorbarlines'):
+	    	locs=npy.arange(lims[0],lims[1]+1,options.getfieldvalue('colorbarlines'))
+	    	cb.add_lines(locs,['k' for i in range(len(locs))],npy.ones_like(locs))
+	    if options.exist('colorbartitle'):
+	        if options.exist('colorbartitlepad'):
+	    	    cb.set_label(options.getfieldvalue('colorbartitle'),\
+                            labelpad=options.getfieldvalue('colorbartitlepad'),fontsize=fontsize)
+	    	else:
+	    	    cb.set_label(options.getfieldvalue('colorbartitle'),fontsize=fontsize)
+	    cb.ax.tick_params(labelsize=fontsize)
+            cb.solids.set_rasterized(True)
+	    cb.update_ticks()
+            cb.set_alpha(1)
+            cb.draw_all()
+	    plt.sca(ax) # return to original axes control
 	#}}}
 
Index: issm/trunk-jpl/src/m/plot/checkplotoptions.py
===================================================================
--- issm/trunk-jpl/src/m/plot/checkplotoptions.py	(revision 19460)
+++ issm/trunk-jpl/src/m/plot/checkplotoptions.py	(revision 19462)
@@ -92,7 +92,7 @@
 		# textweight
 		if options.exist('textweight'):
-			textweightvalues=options.getfieldvalue('textweight')
+			textweight=options.getfieldvalue('textweight')
 			weightlist=[]
-			weightlist.extend(textweight if isinstance(textwieght,list) else [textweight])
+			weightlist.extend(textweight if isinstance(textweight,list) else [textweight])
 		else:
 			weightlist=['normal']
Index: issm/trunk-jpl/src/m/plot/plot_streamlines.py
===================================================================
--- issm/trunk-jpl/src/m/plot/plot_streamlines.py	(revision 19460)
+++ issm/trunk-jpl/src/m/plot/plot_streamlines.py	(revision 19462)
@@ -18,7 +18,8 @@
         streamlinesvy : vy component (default md.initialization.vy)
         streamlinescolor: color string
-        streamlinesdensity: density of plotted streamlines
+        streamlinesdensity: density of plotted streamlines (default 1)
         streamlineswidth: linewidth value or 'vel' to scale by velocity
         streamlineswidthscale: scaling multiplier for linewidth scaled by velocity
+        streamlinesarrowsize: size of arrows on lines (default 1)
         
     '''
@@ -26,8 +27,9 @@
     # retrieve options
     vx=options.getfieldvalue('streamlinesvx',md.initialization.vx)
-    vy=options.getfieldvalue('streamlinesvx',md.initialization.vy)
+    vy=options.getfieldvalue('streamlinesvy',md.initialization.vy)
     color=options.getfieldvalue('streamlinescolor','k')
     linewidth=options.getfieldvalue('streamlineswidth',1)
     density=options.getfieldvalue('streamlinesdensity',1)
+    arrowsize=options.getfieldvalue('streamlinesarrowsize',1)
 
     #process mesh and data 
@@ -60,3 +62,3 @@
 
     # plot streamlines
-    ax.streamplot(xg,yg,ug,vg,color=color,linewidth=linewidth,density=density)
+    ax.streamplot(xg,yg,ug,vg,color=color,linewidth=linewidth,density=density,arrowsize=arrowsize)