Index: issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 19560)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 19561)
@@ -360,4 +360,5 @@
 	/*SMBgemb*/
 	SMBgembEnum,
+	SmbInitDensityScalingEnum,
 	SmbTaEnum,
 	SmbVEnum,
@@ -365,4 +366,5 @@
 	SmbDlwrfEnum,
 	SmbPEnum, 
+	SmbSwfEnum, 
 	SmbEAirEnum, 
 	SmbPAirEnum,
Index: issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 19560)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 19561)
@@ -362,4 +362,5 @@
 		case SmbMassBalanceEnum : return "SmbMassBalance";
 		case SMBgembEnum : return "SMBgemb";
+		case SmbInitDensityScalingEnum : return "SmbInitDensityScaling";
 		case SmbTaEnum : return "SmbTa";
 		case SmbVEnum : return "SmbV";
@@ -367,4 +368,5 @@
 		case SmbDlwrfEnum : return "SmbDlwrf";
 		case SmbPEnum : return "SmbP";
+		case SmbSwfEnum : return "SmbSwf";
 		case SmbEAirEnum : return "SmbEAir";
 		case SmbPAirEnum : return "SmbPAir";
Index: issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 19560)
+++ issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 19561)
@@ -368,4 +368,5 @@
 	      else if (strcmp(name,"SmbMassBalance")==0) return SmbMassBalanceEnum;
 	      else if (strcmp(name,"SMBgemb")==0) return SMBgembEnum;
+	      else if (strcmp(name,"SmbInitDensityScaling")==0) return SmbInitDensityScalingEnum;
 	      else if (strcmp(name,"SmbTa")==0) return SmbTaEnum;
 	      else if (strcmp(name,"SmbV")==0) return SmbVEnum;
@@ -373,4 +374,5 @@
 	      else if (strcmp(name,"SmbDlwrf")==0) return SmbDlwrfEnum;
 	      else if (strcmp(name,"SmbP")==0) return SmbPEnum;
+	      else if (strcmp(name,"SmbSwf")==0) return SmbSwfEnum;
 	      else if (strcmp(name,"SmbEAir")==0) return SmbEAirEnum;
 	      else if (strcmp(name,"SmbPAir")==0) return SmbPAirEnum;
@@ -381,10 +383,10 @@
 	      else if (strcmp(name,"SmbDt")==0) return SmbDtEnum;
 	      else if (strcmp(name,"SmbDz")==0) return SmbDzEnum;
-	      else if (strcmp(name,"SmbAIdx")==0) return SmbAIdxEnum;
-	      else if (strcmp(name,"SmbSwIdx")==0) return SmbSwIdxEnum;
          else stage=4;
    }
    if(stage==4){
-	      if (strcmp(name,"SmbDenIdx")==0) return SmbDenIdxEnum;
+	      if (strcmp(name,"SmbAIdx")==0) return SmbAIdxEnum;
+	      else if (strcmp(name,"SmbSwIdx")==0) return SmbSwIdxEnum;
+	      else if (strcmp(name,"SmbDenIdx")==0) return SmbDenIdxEnum;
 	      else if (strcmp(name,"SmbZTop")==0) return SmbZTopEnum;
 	      else if (strcmp(name,"SmbDzTop")==0) return SmbDzTopEnum;
@@ -504,10 +506,10 @@
 	      else if (strcmp(name,"GiaSolution")==0) return GiaSolutionEnum;
 	      else if (strcmp(name,"GiaAnalysis")==0) return GiaAnalysisEnum;
-	      else if (strcmp(name,"MeshdeformationSolution")==0) return MeshdeformationSolutionEnum;
-	      else if (strcmp(name,"MeshdeformationAnalysis")==0) return MeshdeformationAnalysisEnum;
          else stage=5;
    }
    if(stage==5){
-	      if (strcmp(name,"LevelsetAnalysis")==0) return LevelsetAnalysisEnum;
+	      if (strcmp(name,"MeshdeformationSolution")==0) return MeshdeformationSolutionEnum;
+	      else if (strcmp(name,"MeshdeformationAnalysis")==0) return MeshdeformationAnalysisEnum;
+	      else if (strcmp(name,"LevelsetAnalysis")==0) return LevelsetAnalysisEnum;
 	      else if (strcmp(name,"LevelsetStabilization")==0) return LevelsetStabilizationEnum;
 	      else if (strcmp(name,"ExtrapolationAnalysis")==0) return ExtrapolationAnalysisEnum;
@@ -627,10 +629,10 @@
 	      else if (strcmp(name,"Friction")==0) return FrictionEnum;
 	      else if (strcmp(name,"Internal")==0) return InternalEnum;
-	      else if (strcmp(name,"MassFlux")==0) return MassFluxEnum;
-	      else if (strcmp(name,"MeltingOffset")==0) return MeltingOffsetEnum;
          else stage=6;
    }
    if(stage==6){
-	      if (strcmp(name,"Misfit")==0) return MisfitEnum;
+	      if (strcmp(name,"MassFlux")==0) return MassFluxEnum;
+	      else if (strcmp(name,"MeltingOffset")==0) return MeltingOffsetEnum;
+	      else if (strcmp(name,"Misfit")==0) return MisfitEnum;
 	      else if (strcmp(name,"Pressure")==0) return PressureEnum;
 	      else if (strcmp(name,"PressurePicard")==0) return PressurePicardEnum;
@@ -750,10 +752,10 @@
 	      else if (strcmp(name,"Outputdefinition2")==0) return Outputdefinition2Enum;
 	      else if (strcmp(name,"Outputdefinition3")==0) return Outputdefinition3Enum;
-	      else if (strcmp(name,"Outputdefinition4")==0) return Outputdefinition4Enum;
-	      else if (strcmp(name,"Outputdefinition5")==0) return Outputdefinition5Enum;
          else stage=7;
    }
    if(stage==7){
-	      if (strcmp(name,"Outputdefinition6")==0) return Outputdefinition6Enum;
+	      if (strcmp(name,"Outputdefinition4")==0) return Outputdefinition4Enum;
+	      else if (strcmp(name,"Outputdefinition5")==0) return Outputdefinition5Enum;
+	      else if (strcmp(name,"Outputdefinition6")==0) return Outputdefinition6Enum;
 	      else if (strcmp(name,"Outputdefinition7")==0) return Outputdefinition7Enum;
 	      else if (strcmp(name,"Outputdefinition8")==0) return Outputdefinition8Enum;
@@ -873,10 +875,10 @@
 	      else if (strcmp(name,"MaxVel")==0) return MaxVelEnum;
 	      else if (strcmp(name,"MinVx")==0) return MinVxEnum;
-	      else if (strcmp(name,"MaxVx")==0) return MaxVxEnum;
-	      else if (strcmp(name,"MaxAbsVx")==0) return MaxAbsVxEnum;
          else stage=8;
    }
    if(stage==8){
-	      if (strcmp(name,"MinVy")==0) return MinVyEnum;
+	      if (strcmp(name,"MaxVx")==0) return MaxVxEnum;
+	      else if (strcmp(name,"MaxAbsVx")==0) return MaxAbsVxEnum;
+	      else if (strcmp(name,"MinVy")==0) return MinVyEnum;
 	      else if (strcmp(name,"MaxVy")==0) return MaxVyEnum;
 	      else if (strcmp(name,"MaxAbsVy")==0) return MaxAbsVyEnum;
Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 19560)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 19561)
@@ -354,4 +354,5 @@
 def SmbMassBalanceEnum(): return StringToEnum("SmbMassBalance")[0]
 def SMBgembEnum(): return StringToEnum("SMBgemb")[0]
+def SmbInitDensityScalingEnum(): return StringToEnum("SmbInitDensityScaling")[0]
 def SmbTaEnum(): return StringToEnum("SmbTa")[0]
 def SmbVEnum(): return StringToEnum("SmbV")[0]
@@ -359,4 +360,5 @@
 def SmbDlwrfEnum(): return StringToEnum("SmbDlwrf")[0]
 def SmbPEnum(): return StringToEnum("SmbP")[0]
+def SmbSwfEnum(): return StringToEnum("SmbSwf")[0]
 def SmbEAirEnum(): return StringToEnum("SmbEAir")[0]
 def SmbPAirEnum(): return StringToEnum("SmbPAir")[0]
Index: issm/trunk-jpl/src/m/enum/SmbInitDensityScalingEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/SmbInitDensityScalingEnum.m	(revision 19561)
+++ issm/trunk-jpl/src/m/enum/SmbInitDensityScalingEnum.m	(revision 19561)
@@ -0,0 +1,11 @@
+function macro=SmbInitDensityScalingEnum()
+%SMBINITDENSITYSCALINGENUM - Enum of SmbInitDensityScaling
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
+%            Please read src/c/shared/Enum/README for more information
+%
+%   Usage:
+%      macro=SmbInitDensityScalingEnum()
+
+macro=StringToEnum('SmbInitDensityScaling');
Index: issm/trunk-jpl/src/m/enum/SmbSwfEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/SmbSwfEnum.m	(revision 19561)
+++ issm/trunk-jpl/src/m/enum/SmbSwfEnum.m	(revision 19561)
@@ -0,0 +1,11 @@
+function macro=SmbSwfEnum()
+%SMBSWFENUM - Enum of SmbSwf
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
+%            Please read src/c/shared/Enum/README for more information
+%
+%   Usage:
+%      macro=SmbSwfEnum()
+
+macro=StringToEnum('SmbSwf');