Index: issm/trunk-jpl/src/m/classes/clusters/discover.m
===================================================================
--- issm/trunk-jpl/src/m/classes/clusters/discover.m	(revision 19672)
+++ issm/trunk-jpl/src/m/classes/clusters/discover.m	(revision 19673)
@@ -24,8 +24,5 @@
 		 hyperthreading=0;
 	 end
-	 properties (SetAccess=private) 
-		 np=20*8;
-		 % }}}
-	 end
+	 %}}}
 	 methods
 		 function cluster=discover(varargin) % {{{
@@ -56,4 +53,9 @@
 		 end
 		 %}}}
+		 function numprocs=np(cluster) % {{{
+			 %compute number of processors
+			 numprocs=cluster.numnodes*cluster.cpuspernode;
+		 end
+		 %}}}
 		 function md = checkconsistency(cluster,md,solution,analyses) % {{{
 
@@ -87,7 +89,4 @@
 
 			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
-
-			 %compute number of processors
-			 cluster.np=cluster.numnodes*cluster.cpuspernode;
 
 			 %write queuing script 
Index: issm/trunk-jpl/src/m/classes/clusters/greenplanet.m
===================================================================
--- issm/trunk-jpl/src/m/classes/clusters/greenplanet.m	(revision 19672)
+++ issm/trunk-jpl/src/m/classes/clusters/greenplanet.m	(revision 19673)
@@ -21,8 +21,5 @@
 		 memory        = 2;
 	 end
-	 properties (SetAccess=private) 
-		 np=20*8;
-		 % }}}
-	 end
+	 %}}}
 	 methods
 		 function cluster=greenplanet(varargin) % {{{
@@ -52,4 +49,9 @@
 		 end
 		 %}}}
+		 function numprocs=np(cluster) % {{{
+			 %compute number of processors
+			 numprocs=cluster.numnodes*cluster.cpuspernode;
+		 end
+		 %}}}
 		 function md = checkconsistency(cluster,md,solution,analyses) % {{{
 
@@ -71,7 +73,4 @@
 			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
 			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
-
-			 %compute number of processors
-			 cluster.np=cluster.numnodes*cluster.cpuspernode;
 
 			 %write queuing script 
@@ -101,7 +100,4 @@
 			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
 			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
-
-			 %compute number of processors
-			 cluster.np=cluster.numnodes*cluster.cpuspernode;
 
 			 %write queuing script 
Index: issm/trunk-jpl/src/m/classes/clusters/hpc.m
===================================================================
--- issm/trunk-jpl/src/m/classes/clusters/hpc.m	(revision 19672)
+++ issm/trunk-jpl/src/m/classes/clusters/hpc.m	(revision 19673)
@@ -19,8 +19,5 @@
 		 interactive=0;
 	 end
-	 properties (SetAccess=private) 
-		 np=20*8;
-		 % }}}
-	 end
+	 %}}}
 	 methods
 		 function cluster=hpc(varargin) % {{{
@@ -48,4 +45,9 @@
 		 end
 		 %}}}
+		 function numprocs=np(cluster) % {{{
+			 %compute number of processors
+			 numprocs=cluster.numnodes*cluster.cpuspernode;
+		 end
+		 %}}}
 		 function md = checkconsistency(cluster,md,solution,analyses) % {{{
 
@@ -67,7 +69,4 @@
 			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
 			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
-
-			 %compute number of processors
-			 cluster.np=cluster.numnodes*cluster.cpuspernode;
 
 			 %write queuing script 
@@ -95,7 +94,4 @@
 			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
 			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
-
-			 %compute number of processors
-			 cluster.np=cluster.numnodes*cluster.cpuspernode;
 
 			 %write queuing script 
Index: issm/trunk-jpl/src/m/classes/clusters/lonestar.m
===================================================================
--- issm/trunk-jpl/src/m/classes/clusters/lonestar.m	(revision 19672)
+++ issm/trunk-jpl/src/m/classes/clusters/lonestar.m	(revision 19673)
@@ -21,4 +21,5 @@
 		 time          = 24*60*60;
 	 end
+	 %}}}
 	 methods
 		 function cluster=lonestar(varargin) % {{{
Index: issm/trunk-jpl/src/m/classes/clusters/pfe.m
===================================================================
--- issm/trunk-jpl/src/m/classes/clusters/pfe.m	(revision 19672)
+++ issm/trunk-jpl/src/m/classes/clusters/pfe.m	(revision 19673)
@@ -26,4 +26,5 @@
 		 hyperthreading = 0;
 	 end
+	 %}}}
 	 methods
 		 function cluster=pfe(varargin) % {{{